#ifndef	PEXEXTPROTOST_H
#define	PEXEXTPROTOST_H

/* Common Open Systems Environment, Common Graphics Environment  */		
/* Extension to PEX 5.1 version 2.  File date: March 30, 1994    */		
 
/******************************************************************************/
/*  (c)	Copyright Hewlett-Packard Company, 1993,  Fort Collins,	Colorado      */
/*									      */
/*  (C)	COPYRIGHT International	Business Machines Corp.	1993		      */
/*									      */
/*   Copyright (c) 1993	by Sun Microsystems, Inc.			      */
/*									      */
/*			      All Rights Reserved			      */
/*									      */
/*  Permission to use, copy, modify, and distribute this software and its     */
/*  documentation for any purpose and without fee is hereby granted,	      */
/*  provided that the above copyright notices appear in	all copies and that   */
/*  both the copyright notices and this	permission notice appear in	      */
/*  supporting documentation, and that the names of Hewlett-Packard,	      */
/*  International Business Machines, or	Sun Microsystems not be	used in	      */
/*  advertising	or publicity pertaining	to distribution	of the software	      */
/*  without specific, written prior permission.				      */
/*									      */
/*  HEWLETT-PACKARD MAKES NO WARRANTY OF ANY KIND WITH REGARD TO THIS	      */
/*  SOFTWARE, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF	      */
/*  MERCHANTABILITY AND	FITNESS	FOR A PARTICULAR PURPOSE.  Hewlett-Packard    */
/*  shall not be liable	for errors contained herein or direct, indirect,      */
/*  special, incidental	or consequential damages in connection with the	      */
/*  furnishing,	performance or use of this software.			      */
/*									      */
/*  INTERNATIONAL BUSINESS MACHINES CORPORATION	PROVIDES THIS MATERIAL	      */
/*  "AS	IS" WITHOUT WARRANTY OF	ANY KIND, EITHER EXPRESSED OR IMPLIED,	      */
/*  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY  */
/*  AND	FITNESS	FOR A PARTICULAR PURPOSE.				      */
/*									      */
/*  SUN	MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES WITH REGARD	TO THIS	      */
/*  SOFTWARE, INCLUDING	ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,*/
/*  IN NO EVENT	SHALL SUN MICROSYSTEMS,	INC. BE	LIABLE FOR ANY SPECIAL,	      */
/*  INDIRECT OR	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER	RESULTING     */
/*  FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,      */
/*  NEGLIGENCE OR OTHER	TORTIOUS ACTION, ARISING OUT OF	OR IN CONNECTION      */
/*  WITH THE USE OR PERFORMANCE	OF THIS	SOFTWARE.			      */
/*									      */
/******************************************************************************/

/* Ext types */

typedef	XID	pexExtTextureMap;   
typedef	XID	pexExtTMDescription;
typedef	XID	pexExtDrawable;
typedef	pexMatrix	pexExtParmReflect;  

/* Ext included	in others */

typedef	struct {
    PEXFLOAT	d0 B32;
    PEXFLOAT	d1 B32;
    PEXFLOAT	d2 B32;
    PEXFLOAT	d3 B32;
} pexExtLinearData4;

typedef	struct {
    pexExtLinearData4	p1;	    
    pexExtLinearData4	p2;	    
} pexExtParmLinear;	     

typedef	struct {
    pexEnumTypeIndex	tmType B16;
    pexEnumTypeIndex	texelType B16;
    CARD16		numMapLevels B16;
} pexExtDomainColorData;     

typedef	struct {
    PEXFLOAT		t0 B32;
    PEXFLOAT		t1 B32;
    PEXFLOAT		t2 B32;
} pexExtFrequency;	     

typedef	struct {
    pexEnumTypeIndex	method B16;
    CARD16		length B16;
    /* LISTof CARD8( paramLength )  */
    /* The list	may contain the	following depending on the method */
    /*	 SINGLE	pexExtParmReflect or				  */
    /*	 SINGLE	pexExtParmLinear or				  */
    /*	 LISTof	CARD8 -	implementation dependent data		  */
    /* pad */
} pexExtParamData;	      

/* Ext Texel structures	*/
typedef	struct {
    PEXFLOAT	luminance B32;
    PEXFLOAT	alpha B32;
} pexExtTexelLuminanceAlpha;

typedef	struct {
    CARD8	luminance;   
    CARD8	alpha;
    CARD16	unused B16;
} pexExtTexelLuminanceAlpha8;

typedef	struct {
    CARD16	luminance B16;
    CARD16	alpha B16;
} pexExtTexelLuminanceAlpha16;

typedef	struct {
    PEXFLOAT	luminance B32;
} pexExtTexelLuminance;

typedef	struct {
    CARD8	luminance;
    CARD8	unused1;
    CARD16	unused2	B16;
} pexExtTexelLuminance8;

typedef	struct {
    CARD16	luminance B16;		/* no Pad */
    CARD16	unused B16;
} pexExtTexelLuminance16;

typedef	struct {
    PEXFLOAT	red B32;
    PEXFLOAT	green B32;
    PEXFLOAT	blue B32;
    PEXFLOAT	alpha B32;
} pexExtTexelRGBAlpha;

typedef	struct {
    CARD8	red;
    CARD8	green;
    CARD8	blue;
    CARD8	alpha;
} pexExtTexelRGBAlpha8;

typedef	struct {
    CARD16	red B16;
    CARD16	green B16;
    CARD16	blue B16;
    CARD16	alpha B16;
} pexExtTexelRGBAlpha16;

typedef	struct {
    PEXFLOAT	red B32;
    PEXFLOAT	green B32;
    PEXFLOAT	blue B32;
} pexExtTexelRGB;

typedef	struct {
    CARD8	red;
    CARD8	green;
    CARD8	blue;
    CARD8	unused;
} pexExtTexelRGB8;

typedef	struct {
    CARD16	red B16;
    CARD16	green B16;
    CARD16	blue B16;
    CARD16	unused B16;
} pexExtTexelRGB16;

typedef	struct {
    CARD16	t0 B16;
    CARD16	t1 B16;
    CARD16	t2 B16;
    CARD16	unused B16;
} pexExtTexelDimension;

/* Ext texture structure */

typedef	struct {
    pexExtTexelDimension	dimension B16;
    /* LISTof pexExtTexel( dimension, texelType	) */		   
} pexExtTexelArray;

/*
 * typedefs for	Ext lookup tables
 */

typedef	struct {
    pexExtTMDescription	     tmDescription B32;
    pexTableIndex	coordinateLutIndex B16;
    pexTableIndex	compositionLutIndex B16;
    pexTableIndex	samplingLutIndex B16;
    CARD16		unused B16;
} pexExtTMBindingEntry;

typedef	struct {
    pexEnumTypeIndex	tmSource B16;
    CARD16		fpDataIndex B16;
    pexMatrix		orientation;	
} pexExtTMCoordSourceEntry;

typedef	struct {
    pexEnumTypeIndex	method B16;
    CARD16		lengthCompositeData B16;
    /* LISTof CARD8( lengthCompositeData )  */
    /* The list	may contain the	following depending on the method	    */
    /* SINGLE CARD16		 channel_number				    */
    /* SINGLE CARD16		 unused					    */
    /* SINGLE pexColorSpecifier	 blendEnvColor or decalBkgdColor or color1  */
    /* SINGLE pexColorSpecifier	 color2					    */
    /* SINGLE pexImpDepData						    */
    /* pad */
} pexExtTMCompositionEntry;

/*
    Note that since a TMSamplingEntry contains an embedded instance of
    pexColorSpecifier, a variable-sized	item, a	data structure cannot be
    defined for	it.
*/
typedef	struct {
    pexEnumTypeIndex	minification B16;
    pexEnumTypeIndex	magnification B16;
    pexEnumTypeIndex	t0Boundary B16;
    pexEnumTypeIndex	t1Boundary B16;
    pexEnumTypeIndex	t2Boundary B16;
    pexEnumTypeIndex	clampColorSource B16;
    /* SINGLE pexColorSpecifier		clampColor    */
    /* SINGLE FLOAT			depthHint     */
    /* SINGLE pexExtFrequency		tFrequency    */
} pexExtTMSamplingEntry;


/* Ext PEX Escapes */

typedef	struct {
    pexEnumTypeIndex	fpFormat B16;
    CARD16		numArrays B16;
    pexExtTextureMap	tmId B32;
    pexEnumTypeIndex	domain B16;
    pexEnumTypeIndex	tmType B16;
    pexEnumTypeIndex	texelType B16;
    CARD16		numMapLevels B16;
    CARD32		listLength B32;
    /* LISTof pexExtTexelArray(	numArrays )  */
    /*	note: remaining	pieces go in CreateTMExtraData escape  */
} pexExtCreateTMData;

typedef	struct {
    pexEnumTypeIndex	fpFormat B16;
    pexEnumTypeIndex	paramMethod B16;
    pexExtTMDescription	tmDescriptionId	B32;
    CARD16		tmRenderingOrder B16;
    CARD16		paramLength B16;
    CARD16		numTMIds B16;
    CARD16		unused B16;
    pexExtParamData	paramData;
    /* LISTof XID( numTMIds )	 */
} pexExtCreateTMDescriptionData;

typedef	struct {
    pexExtTextureMap	tmId B32;
    /* LISTof CARD32  -	remaining pieces of pexExtTexelArray( numArrays	)  */
} pexExtCreateTMExtraDataData;

typedef	struct {
    pexExtTextureMap		tmId;
} pexExtFreeTMData;

typedef	struct {
    pexExtTMDescription		tmDescriptionId;
} pexExtFreeTMDescriptionData;

typedef	struct
{
    pexEnumTypeIndex	fpFormat B16;
    CARD16		unused;		
    pexExtDrawable	drawable;    /*	Drawable to compare capx against   */
    /* SINGLE pexColorApproxEntry	 Color approx to check		   */
} pexExtQueryColorApproxData;

typedef	struct
{
    pexSwitch	capxIsSupported;     /*	True if	given input approx supported */
    pexSwitch	allCapxs;	     /*	True if	all alt	capx's are returned  */
    CARD8	unused1[2];
    CARD32	count B32;	    /* Number of alternative color approx's */
    CARD8	unused2[12];
    /* LISTof pexColorApproxEntry( count ) */
} pexExtQueryColorApproxReplyData;

#endif /* PEXEXTPROTOST_H */

